package gxpconvert;

import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.Transferable;
import java.awt.datatransfer.UnsupportedFlavorException;
import java.io.File;
import java.io.IOException;
import java.util.List;

import javax.swing.TransferHandler;

import org.apache.commons.io.FilenameUtils;

public class DropTranspherHandler extends TransferHandler {

	private static final long serialVersionUID = 1L;
	private GPXConverterI gpxConverter;

	public DropTranspherHandler(GPXConverterI pGPXConverterI) {
		gpxConverter = pGPXConverterI;
	}

	@Override
	public boolean canImport(TransferSupport pTransferSupport) {
		boolean result = false;
		result = pTransferSupport.isDataFlavorSupported(DataFlavor.javaFileListFlavor);
		return result;
	}

	// =========================================================================

	@SuppressWarnings("unchecked")
	@Override
	public boolean importData(TransferSupport pSup) {
		boolean result = false;
		if (canImport(pSup)) {
			// Fetch the Transferable and its data
			Transferable t = pSup.getTransferable();
			List<String> list;
			try {
				list = (List<String>) t.getTransferData(DataFlavor.javaFileListFlavor);
				for (Object o : list) {
					String srcFileName = o.toString();
					File srcFile = new File(srcFileName);
					File dstFile = getDestFile(srcFileName);
					if (srcFile.isFile() && srcFile.canRead()) {
						boolean convResult = gpxConverter.convertgpxFile(srcFile, dstFile);
						if (convResult) {

						}
					}
				}
				result = true;
			} catch (UnsupportedFlavorException | IOException e) {
				e.printStackTrace();
			}
		}
		return result;

	}

	// =========================================================================

	private File getDestFile(String pSrcName) {
		File result;
		int maxcount = 1;
		boolean nameFound = false;
		String path = FilenameUtils.getFullPath(pSrcName);
		String base = FilenameUtils.getBaseName(pSrcName);
		String ext = FilenameUtils.getExtension(pSrcName);
		String newName;
		String numExt = "";
		do {
			newName = path + base + "_OruxNavi" + numExt + "."+ext;
			result = new File(newName);
			if (!result.exists()) {
				nameFound = true;
			}
			numExt = "(" + String.valueOf(maxcount) + ")";
			maxcount++;
		} while (nameFound == false && maxcount < 100);

		return result;

	}

}
